/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.edu.mimuw.bioputer.tav4sb.logic.mathematica.worker;

import com.wolfram.jlink.MathLinkException;
import pl.edu.mimuw.bioputer.tav4sb.consumer.task.AbstractWorker;
import pl.edu.mimuw.bioputer.tav4sb.logic.mathematica.proc.SelectObservables;
import pl.edu.mimuw.bioputer.tav4sb.services.xsd.mathematica.SelectObservablesParams;
import pl.edu.mimuw.bioputer.tav4sb.services.xsd.mathematica.SelectObservablesResult;
import pl.edu.mimuw.bioputer.tav4sb.services.xsd.mathematica.Trajectories;
import pl.edu.mimuw.bioputer.tav4sb.utils.xml.XmlTranslator;

/**
 *
 * @author michal
 */
public class SelectObservablesWorker extends AbstractWorker<SelectObservablesParams, SelectObservablesResult> {

    public SelectObservablesWorker(XmlTranslator<SelectObservablesResult, SelectObservablesParams> translator) {
        super(translator);
    }

    @Override
    public SelectObservablesResult doExecute(SelectObservablesParams param) throws MathLinkException {
        Trajectories res = SelectObservables.selectObservables(param.getMethod(), param.getTrajectories(),
                param.getNames().getString(), param.getFormulas().getString());
        SelectObservablesResult sor = new SelectObservablesResult();
        sor.setTrajectories(res);
        return sor;
    }
}
