/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pl.edu.mimuw.bioputer.tav4sb.logic.mathematica.worker;

import pl.edu.mimuw.bioputer.tav4sb.consumer.task.WorkerFactory;
import pl.edu.mimuw.bioputer.tav4sb.services.xsd.mathematica.ClassifySamplesParams;
import pl.edu.mimuw.bioputer.tav4sb.services.xsd.mathematica.ClassifySamplesResult;
import pl.edu.mimuw.bioputer.tav4sb.utils.xml.XmlTranslator;

/**
 *
 * @author michal
 */
public class ClassifySamplesWorkerFactory implements WorkerFactory {
    public static final String context = "pl.edu.mimuw.bioputer.tav4sb.services.xsd.mathematica";
    private static final ClassifySamplesWorkerFactory instance = new ClassifySamplesWorkerFactory();
    private static final XmlTranslator<ClassifySamplesResult, ClassifySamplesParams> translator =
            new XmlTranslator<ClassifySamplesResult, ClassifySamplesParams>(context);

    private ClassifySamplesWorkerFactory() {
    }

    public static ClassifySamplesWorkerFactory getInstance() {
        return instance;
    }

    public ClassifySamplesWorker getWorker() {
        return new ClassifySamplesWorker(translator);
    }

}
