/*******************************************************************************
 * Copyright (C) 2011 Mikołaj Rybiński
 * 
 *     This file is part of Tav4SB.
 * 
 *     Tav4SB is free software: you can redistribute it and/or modify it under the
 *     terms of the GNU Affero General Public License as published by the Free
 *     Software Foundation, either version 3 of the License, or (at your option)
 *     any later version.
 * 
 *     Tav4SB is distributed in the hope that it will be useful, but WITHOUT ANY
 *     WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 *     FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for
 *     more details.
 * 
 *     You should have received a copy of the GNU Affero General Public License
 *     along with Tav4SB. If not, see <http://www.gnu.org/licenses/>.
 * 
 *     Contributors:
 *         Paweł Banasik - initial implementation
 *         Michał Lula - grid implementation
 *         Mikołaj Rybiński - implementation and maintenance
 ******************************************************************************/
package pl.edu.mimuw.bioputer.tav4sb.producer.utils;

import pl.edu.mimuw.bioputer.tav4sb.utils.props.PropertiesWrapper;

public class ProducerProperties extends PropertiesWrapper {
    private static final String path = "producer.properties";
    @Override
    protected String getPath() {
        return path;
    }

    public static final String ASYNC_REGISTER_TIMEOUT = "ASYNC_REGISTER_TIMEOUT";
    public final int getAsyncRegisterTimeout() {
        return getIntProperty(ASYNC_REGISTER_TIMEOUT);
    }
}
